from typing import List
from models.availability import Availability
from re import A
import re
from os import error

from bson.objectid import ObjectId
from schemas.doctor import doctorEntity, doctorsEntity, doctorGetEntity
from schemas.availability import availabilityEntity, availabilitiesEntity
from fastapi import APIRouter
from models.doctor import Doctor
from config.db import conn

doctor = APIRouter()

@doctor.get('/api/doctors')
async def find_all_doctors():
    return doctorsEntity(conn.skinDiseaseDB.doctor.find())

@doctor.get('/api/doctor/{id}')
async def find_one_doctor(id):
    try:
        return doctorEntity(conn.skinDiseaseDB.doctor.find_one({"id":id}))
    except error:
        print(error)
        return {"success": False, "msg": error}
        

@doctor.post('/api/doctor')
async def create_doctor(doctor: Doctor):
    try:
        conn.skinDiseaseDB.doctor.insert_one(dict(doctor))
        return {"success": True}
    except error: 
        return {"success": False, "msg": error}

@doctor.put('/api/doctor/{id}')
async def update_doctor(id, doctor: Doctor):
    try:
        conn.skinDiseaseDB.doctor.find_one_and_update({"id":id},{"$set": dict(doctor)})
        return {"success": True}
    except error: 
        return {"success": False, "msg": error}

@doctor.delete('/api/doctor/{id}')
async def delete_doctor(id):
    try:
        result = doctorEntity(conn.skinDiseaseDB.doctor.find_one_and_delete({"id": id}))
        return {"success": True}
    except:
        return {"success": False}


@doctor.put('/api/availability/{id}')
async def update_availability(id, availabilities: List[Availability]):
    try:
        available_dic = dict()
        for available in availabilities:
            print(available)
        
        #conn.skinDiseaseDB.doctor.find_one_and_update({"id":id},{"$set": {'isAvailable': isAvailable}})
        return availabilities
    except error: 
        return {"success": False, "msg": error}





















