from typing import List
from fastapi import APIRouter
from os import error
import pandas as pd
import numpy as np
import json
import os

prediction = APIRouter()

def load_data_json(path=''):
  with open(path, 'r') as fp:
    data = json.load(fp)
  fp.close()
  return data

@prediction.post('/api/predictions/symptoms')
async def predict_symptoms(symptoms: List[int]):
    try:
        data = load_data_json('./data.json')
        threshold = 0.5
        input = set(symptoms)
        output = []
        for key in data.keys():
            numbers = [int(i) for i in key.split(',') if int(i) != 0]
            lenght = len(numbers)
            score = len(list(input&set(numbers)))/lenght
            if score>=threshold:
                output.append(data.get(key))
                
        return {"success": True, "result": output}  
        
    except error: 
        return {"success": False, "msg": error}



